| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Protected Member Functions | Protected Attributes | Static Protected Attributes | Properties | Private Member Functions | Private Attributes | List of all members
IG.Gr3d.VtkPlotter Class Reference

Plotter class that uses a vtkRenderWindow object for plotting 3D graphics. More...

Inheritance diagram for IG.Gr3d.VtkPlotter:
[legend]
Collaboration diagram for IG.Gr3d.VtkPlotter:
[legend]

## Classes
class | Accessor
| Class that is used to access the VtkPlotter's window in classes that are not derived from that class. Access can be granted by either inheriting from this class or by uding this class as proxy class. More...

## Public Member Functions
| VtkPlotter ()
| VtkPlotter (vtkRenderWindow window)
| Constructor. More...
| VtkPlotter (IVtkFormContainer formContainer)
| Constructor. More...
| VtkPlotter (Kitware.VTK.RenderWindowControl renderControl)
| Constructor. More...
void | ResetCamera ()
| Resets the camera position and shows complete plots. More...
void | SetWindow (vtkRenderWindow win)
| Sets the VTK render window. More...
IVtkFormContainer | CreateVtkFormContainer ()
| Tries to create and return a valid VTK Form container (of type IVtkFormContainer) that actually contains a VTK renderer control of type Kitware.VTK.RenderWindowControl. More...
bool | ContainsPlotObject (VtkPlotBase plotObject)
| Returns true if the specified VTK plotting object is contained on (registered with) the current VtkPlotter object, or false otherwise. More...
void | AddPlotObject (VtkPlotBase plotObject)
| Adds the specified plotting object to the list of plotting objects of the current VTK plotter. More...
void | AddPlotObjects (params VtkPlotBase[] plotObjects)
| Adds the specified plotting objects to the list of plotting objects of the current VTK plotter. More...
void | RemovePlotObject (VtkPlotBase plotObject)
| Removes the specified plotting object from the list of plotting objects of the current VTK plotter, and disposes unmanaged resources used by that object. More...
void | RemovePlotObjects (params VtkPlotBase[] plotObjects)
| Removes the specified plotting objects from the list of plotting objects of the current VTK plotter, and disposes unmanaged resources used by that objects. More...
void | setRenderer (vtkRenderer renderer)
| Sets the plotter's renderer. More...
int | GetRendererIndex (vtkRenderer renderer)
| Returns index of the specified renderer on the VTK window of the current plotter, or -1 if the specified renderer is not contaied in the window. More...
int | AddRenderer (vtkRenderer renderer, bool setActive)
| Adds the specified renderer to the VTK window of the current plotter object, and returns its index. More...
void | AddActor (vtkActor actor)
| Adds the specified actor to the active renderer fo the current VTK plotter. More...
void | RemoveAllActors ()
| Clears the active renderer (removes all actors on it). More...
void | RemoveActor (vtkActor actor)
| Removes the specified actor form the active renderer (if it exists on that renderer) and from any other renderer on which it is included (if not found on the active renderer) Nothing happens if the actor is not found on any renderer. More...
void | AddActor2D (vtkActor2D actor)
| Adds the specified 2D actor to the active renderer fo the current VTK plotter. More...
void | RemoveAllActor2Ds ()
| Clears the active renderer of 2D actors (removes all 2D actors on it). More...
void | RemoveActor2D (vtkActor2D actor)
| Removes the specified 2D actor form the active renderer (if it exists on that renderer) and from any other renderer on which it is included (if not found on the active renderer). Nothing happens if the actor is not found on any renderer. More...
void | CalculateBoundsFromPlotsBounds ()
| Recalculates bounds on co-ordinates according to all plots that are contained in the current plotter. More...
void | CalculateBoundsFromPlotsActors ()
| Recalculates bounds on co-ordinates according to all plots that are contained in the current plotter. More...
void | ShowPlotWithoutRender ()
| Basic things that must be done when showing the plot. More...
void | ShowPlot ()
| Shows the plot in the rendering window and allows user interactor for rotating, zooming, etc. More...
void | SetBoundsScaled (IBoundingBox bounds)
| Sets the bounds of scaled graphs. More...
void | ScaleCoordinatesPlain (IVector original, ref IVector scaled)
| Scales coordinates from the physical (original) coordinate system to the scaled graphical coordinates. More...
void | CalculateScalingParameters ()
| Calculates parameters for performing mapping on VTK actors. More...
void | ScaleActor (vtkActor actor)
| Performs scaling on the specified VTK actor. More...
void | ScaleActorPlain (vtkActor actor)
| Performs scaling on the specified VTK actor. More...
void | ScaleActors ()
| Scales all actors on all plots of the bounding box. More...
void | ScaleDecorations ()
| Scales decorations, including the axes, according to scaling defined on this plotter. More...
void | Dispose ()
| Implementation of IDisposable interface. More...

## Static Public Member Functions
static void | ExampleAddTestGraph (VtkPlotter plotter)
| Adda a test graphics (a simple surface plot) to the specified plotter. More...

## Public Attributes
VtkDecorationHandler | _decorationHandler
const bool | DefaultFormContainerModal = true
| Default value of the flag that specifies whether VTK form containers are launched as modal forms. More...

## Static Public Attributes
static color | DefaultBackground = new color(1,1,1)
| Default background color for new windows. More...
static bool | DefaultIsAllowedVtkForm = false
| Default value for flag indicating whether the VtkForm is used for standalone VTK windows. More...
static bool | DefaultIsAllowedVtkFormPlain = true
| Default value for flag indicating whether the VtkFormPlain is used for stand-alone VTK windows. More...
static bool | DefaultFormContainerParallel = false
| Default value of the flag that specifies whether or not form containers that contain VTK graphics are launched in parallel thread. More...

## Protected Member Functions
void | ShowPlotEventhandler ()
void | ShowFormContainerInThread ()
| Launches the form container. More...
void | ShowFormContainer ()
| Shows the form container. More...
virtual void | Dispose (bool disposing)
| Does the job of freeing resources. More...

## Protected Attributes
bool | _isAllowedVtkForm = DefaultIsAllowedVtkForm
bool | _isAllowedVtkFormPlain = DefaultIsAllowedVtkFormPlain
List< VtkPlotBase > | _plotObjects
bool | _skipNullWindowCheck = false
bool | _windowCreated = false
| Whether the VTK window has been created, used for internal communication between some methods. More...
bool | _isScaled = false
vec3 | ScalingFactors = new vec3()
| Scaling factors - mapping parameters used when scaling VTK actors. More...
vec3 | ScalingTranslations = new vec3()
| Scaling translations - mapping parameters used when scaling VTK actors. More...

## Static Protected Attributes
static int | _defaultOutputLevel = -1

## Properties
object | Lock`[get]`
| This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock. More...
static int | DefaultOutputLevel`[get, set]`
| Gets or sets the default level of output for this class. More...
int | OutputLevel`[get, set]`
| Level of output to the console for the current object. More...
bool | IsWindowStandalone`[get, set]`
| Whether a stand-alone window is launched to render the scene. More...
int | WindowSizeX`[get, set]`
| Window size in x direction (used when a stand-alone window is launched for rendering). More...
int | WindowSizeY`[get, set]`
| Window size in y direction (used when a stand-alone window is launched for rendering). More...
int | WindowPositionX`[get, set]`
| Window position in x direction (used when a stand-alone window is launched for rendering). More...
int | WindowPositionY`[get, set]`
| Window position in y direction (used when a stand-alone window is launched for rendering). More...
color | BackGround`[get, set]`
| Background color for the current plotter. More...
vtkRenderWindow | Window`[get, set]`
| VTK window used for rendering 3D graphics. Warning: setter should only be used in constructors. More...
static bool | DefaultIsAllowedAnyVtkForm`[get, set]`
| Modifies or retrieves a boolean value indicating whether any VTK form can be used by plotters of the current type for standalone VTK windows by default. More...
bool | IsAllowedAnyVtkForm`[get, set]`
| Modifies or retrieves a boolean value indicating whether any VTK form can be used for standalone VTK windows by the current plotter. More...
bool | IsAllowedVtkForm`[get, set]`
| Whether the VtkForm is used for standalone VTK windows. More...
bool | IsAllowedVtkFormPlain`[get, set]`
| Whether the VtkFormPlain is used for stand-alone VTK windows. More...
IVtkFormContainer | FormContainer`[get, set]`
| Form that eventually contains VTK render control (of type Kitware.VTK.RenderWindowControl). More...
Kitware.VTK.RenderWindowControl | RenderControl`[get, set]`
| VTK control of type Kitware.VTK.RenderWindowControl that can be used for rendering VTK graphics. More...
VtkDecorationHandler | DecorationHandler`[get, protected set]`
| Decoration handler that handles graph axes, title, labels, etc. More...
List< VtkPlotBase > | PlottingObjects`[get, set]`
| List of plotting objects contained on the current class. More...
int | NumRenderers`[get]`
| Returns the number of renderers that are currently attached to the VTK window that is associated with the current VTK plotter object. More...
int | ActiveRendererIndex`[get, set]`
| Gets or sets the index of the active renderer. This is the renderer on which mathod such as AddActor operate. More...
vtkRenderer | Renderer`[get, set]`
| Gets the active renderer of the current VTK plotter. More...
BoundingBox3d | BoundsCoordinates`[get, protected set]`
| Bounds on coordinates of points that define the plots. Everything on the plot should fit in these bounds. More...
bool | FormContainerModal`[get, set]`
| Whether or not VTK form containers are launched as modal forms. More...
bool | FormContainerParallel`[get, set]`
| Whether or not form containers that contain VTK graphics are launched in parallel thread. More...
bool | IsScaled`[get, set]`
| Specifies whether coordinates of graphic objects are scaled when plottting. More...
BoundingBox3d | BoundsScaled`[get, protected set]`
| Bounds on scaled coordinates graphic objects. Everything on the scaled plot should fit in these bounds. More...
Properties inherited from IG.Lib.ILockable
object | Lock`[get]`

## Private Member Functions
| ~VtkPlotter ()

## Private Attributes
object | _mainLock = new object()
int | _outputLevel = DefaultOutputLevel
bool | _isWindowStandalone = true
int | _windowSizeX = 600
int | _windowSizey = 600
int | _windowPositionX = 100
int | _windowPositionY = 50
color | _backGround = DefaultBackground
vtkRenderWindow | _window
IVtkFormContainer | _formContainer
Kitware.VTK.RenderWindowControl | _renderControl
int | _activeRendererIndex = 0
vtkRenderer | _activeRenderer
BoundingBox3d | _boundsCoordinates
bool | _formContainerModal = DefaultFormContainerModal
bool | _formContainerParallel = DefaultFormContainerParallel
BoundingBox3d | _boundsScaled
Vector3d | vecOriginal = new Vector3d(0)
Vector3d | vecScaled = new Vector3d(0)
bool | disposed = false

## Detailed Description

Plotter class that uses a vtkRenderWindow object for plotting 3D graphics.

$A Igor xx Oct11;

## Constructor & Destructor Documentation

IG.Gr3d.VtkPlotter.VtkPlotter | ( |  | ) |
| inline

IG.Gr3d.VtkPlotter.VtkPlotter | ( | vtkRenderWindow | window | ) |
| inline

Constructor.

If a VTK window used for plotting is not specified (i.e., it is null) then a new window will be opened.

Parameters

  window | VTK window to be used for plotting.

IG.Gr3d.VtkPlotter.VtkPlotter | ( | IVtkFormContainer | formContainer | ) |
| inline

Constructor.

Parameters

  formContainer | VTK form container to be used for access to VTK render window for plotting.

IG.Gr3d.VtkPlotter.VtkPlotter | ( | Kitware.VTK.RenderWindowControl | renderControl | ) |
| inline

Constructor.

Parameters

  formContainer | VTK control used for plotting.

IG.Gr3d.VtkPlotter.~VtkPlotter | ( |  | ) |
| inline private

## Member Function Documentation

void IG.Gr3d.VtkPlotter.ResetCamera | ( |  | ) |
| inline

Resets the camera position and shows complete plots.

$A Tako78 Oct12;

Referenced by IG.Gr3d.VtkPlotBase.ExampleSurfacePlot(), IG.Gr3d.VtkPlotBase.ExampleSurfacePlotManualScaled(), IG.Gr3d.VtkPlotBase.ExampleSurfacePlotScaled(), and IG.Forms.VectorFunctionPlotter2d.PlotParametricTest().

void IG.Gr3d.VtkPlotter.SetWindow | ( | vtkRenderWindow | win | ) |
| inline

Sets the VTK render window.

Use only in exceptional cases!

Parameters

  win | Window to be set.

Referenced by IG.Gr3d.VtkFormsExamples.Plot3dFunctionVtkControl().

IVtkFormContainer IG.Gr3d.VtkPlotter.CreateVtkFormContainer | ( |  | ) |
| inline

Tries to create and return a valid VTK Form container (of type IVtkFormContainer) that actually contains a VTK renderer control of type Kitware.VTK.RenderWindowControl.

Which type of forms are attempted to create is specified by properties like IsAllowedVtkForm and IsAllowedVtkFormPlain.

In some settings of conditional compilation, classes that should contain a proper VTK renderer control actually don't contain it. Therefore, this must be verified and a non-null object is returned only if it actually contains the proper VTK render control.

References IG.Gr3d.IVtkFormContainerGen< VtkControlType >.VtkRenderWindowControl.

bool IG.Gr3d.VtkPlotter.ContainsPlotObject | ( | VtkPlotBase | plotObject | ) |
| inline

Returns true if the specified VTK plotting object is contained on (registered with) the current VtkPlotter object, or false otherwise.

Parameters

  plotObject | Plotting object to be checked.

void IG.Gr3d.VtkPlotter.AddPlotObject | ( | VtkPlotBase | plotObject | ) |
| inline

Adds the specified plotting object to the list of plotting objects of the current VTK plotter.

If the object is already on the list of plotting objects then it is not inserted again.

Parameters

  plotObject | VTK plotting object to be added on the currrent VtkPlotter object.

Referenced by IG.Gr3d.VtkPlotBase.VtkPlotBase().

void IG.Gr3d.VtkPlotter.AddPlotObjects | ( | params VtkPlotBase[] | plotObjects | ) |
| inline

Adds the specified plotting objects to the list of plotting objects of the current VTK plotter.

Parameters

  plotObjects | Objects to be added to the list.

void IG.Gr3d.VtkPlotter.RemovePlotObject | ( | VtkPlotBase | plotObject | ) |
| inline

Removes the specified plotting object from the list of plotting objects of the current VTK plotter, and disposes unmanaged resources used by that object.

If the specified object is not on the list of plotting objects then nothing happens.

Parameters

  plotObject | VTK plotting object to be removed from the currrent VtkPlotter object.

References IG.Gr3d.VtkPlotBase.Dispose().

void IG.Gr3d.VtkPlotter.RemovePlotObjects | ( | params VtkPlotBase[] | plotObjects | ) |
| inline

Removes the specified plotting objects from the list of plotting objects of the current VTK plotter, and disposes unmanaged resources used by that objects.

If no objects are specified then nothing happens. Also for the specified objects that are null or are not on the list, nothing happens. If removing one of the objects throws an exception then the remaining objects are removed without any disturbance.

Parameters

  plotObjects | Objects to be removed from the list.

void IG.Gr3d.VtkPlotter.setRenderer | ( | vtkRenderer | renderer | ) |
| inline

Sets the plotter's renderer.

This should be used only exceptionally. Access may be degraded to protected in the future and method accessed through accessor class.

Parameters

  renderer | New renderer (can be null).

Referenced by IG.Gr3d.VtkFormsExamples.Plot3dFunctionVtkControl().

int IG.Gr3d.VtkPlotter.GetRendererIndex | ( | vtkRenderer | renderer | ) |
| inline

Returns index of the specified renderer on the VTK window of the current plotter, or -1 if the specified renderer is not contaied in the window.

This method can be used for setting active renderer through its reference (use the returned index in ActiveRendererIndex() since there is no direct method to set active renderer by its reference.

Parameters

  renderer | Renderer whose index is returned.

References IG.Gr3d.UtilVtk.GetRenderers().

int IG.Gr3d.VtkPlotter.AddRenderer | ( | vtkRenderer | renderer,
|  | bool | setActive
| ) |  |
| inline

Adds the specified renderer to the VTK window of the current plotter object, and returns its index.

If the specified renderer already exist on the plotter object, then only its index is returned.

If specified so by the setActive parameter then the specified renderer also becomes the active renderer active after adding.

Parameters

  renderer | Renderer to be added.
  setActive | If true then the specified renderer is set as active renderer.

References IG.Gr3d.UtilVtk.ContainsRenderer(), and IG.Gr3d.UtilVtk.GetNumRenderers().

void IG.Gr3d.VtkPlotter.AddActor | ( | vtkActor | actor | ) |
| inline

Adds the specified actor to the active renderer fo the current VTK plotter.

Parameters

  actor |

References IG.Gr3d.UtilVtk.ContainsActor().

void IG.Gr3d.VtkPlotter.RemoveAllActors | ( |  | ) |
| inline

Clears the active renderer (removes all actors on it).

References IG.Gr3d.UtilVtk.GetRenderers(), and IG.Gr3d.UtilVtk.RemoveAllActors().

void IG.Gr3d.VtkPlotter.RemoveActor | ( | vtkActor | actor | ) |
| inline

Removes the specified actor form the active renderer (if it exists on that renderer) and from any other renderer on which it is included (if not found on the active renderer) Nothing happens if the actor is not found on any renderer.

Parameters

  actor | Actor to be removed.

References IG.Gr3d.UtilVtk.ContainsActor(), and IG.Gr3d.UtilVtk.GetRenderers().

void IG.Gr3d.VtkPlotter.AddActor2D | ( | vtkActor2D | actor | ) |
| inline

Adds the specified 2D actor to the active renderer fo the current VTK plotter.

Parameters

  actor | A 2D actor to be added.

References IG.Gr3d.UtilVtk.ContainsActor2D().

void IG.Gr3d.VtkPlotter.RemoveAllActor2Ds | ( |  | ) |
| inline

Clears the active renderer of 2D actors (removes all 2D actors on it).

References IG.Gr3d.UtilVtk.GetRenderers(), and IG.Gr3d.UtilVtk.RemoveAllActors2D().

void IG.Gr3d.VtkPlotter.RemoveActor2D | ( | vtkActor2D | actor | ) |
| inline

Removes the specified 2D actor form the active renderer (if it exists on that renderer) and from any other renderer on which it is included (if not found on the active renderer). Nothing happens if the actor is not found on any renderer.

Parameters

  actor | The 2D actor to be removed.

References IG.Gr3d.UtilVtk.ContainsActor2D(), and IG.Gr3d.UtilVtk.GetRenderers().

void IG.Gr3d.VtkPlotter.CalculateBoundsFromPlotsBounds | ( |  | ) |
| inline

Recalculates bounds on co-ordinates according to all plots that are contained in the current plotter.

References IG.Gr3d.VtkPlotBase.BoundsCoordinates.

void IG.Gr3d.VtkPlotter.CalculateBoundsFromPlotsActors | ( |  | ) |
| inline

Recalculates bounds on co-ordinates according to all plots that are contained in the current plotter.

References IG.Gr3d.VtkPlotBase.UpdateBoundsOnActors().

void IG.Gr3d.VtkPlotter.ShowPlotEventhandler | ( |  | ) |
| inline protected

void IG.Gr3d.VtkPlotter.ShowPlotWithoutRender | ( |  | ) |
| inline

Basic things that must be done when showing the plot.

Referenced by IG.Gr3d.VtkControlBase.ExampleExternalLoadVtkGraphics_SurfacePlots(), and IG.Gr3d.VtkControlBase.VtkControlBase_LoadVtkGraphics().

static void IG.Gr3d.VtkPlotter.ExampleAddTestGraph | ( | VtkPlotter | plotter | ) |
| inline static

Adda a test graphics (a simple surface plot) to the specified plotter.

Parameters

  plotter | Plotter where test graphics is added.

References IG.Gr3d.VtkSurfacePlot.Create(), IG.Gr3d.VtkSurfacePlotBase.LineColorIsScaled, IG.Gr3d.VtkSurfacePlotBase.LinesVisible, IG.Gr3d.VtkSurfacePlotBase.LineWidth, IG.Gr3d.VtkContourPlot.NumContours, IG.Gr3d.VtkSurfacePlot.NumX, IG.Gr3d.VtkSurfacePlot.NumY, IG.Gr3d.VtkPlotBase.OutputLevel, IG.Gr3d.VtkSurfacePlotBase.PointSize, IG.Gr3d.VtkSurfacePlotBase.PointsVisible, IG.Gr3d.VtkSurfacePlot.SetBoundsParameters(), IG.Gr3d.VtkSurfacePlot.SetSurfaceDefinition(), IG.Gr3d.VtkSurfacePlotBase.SurfaceColor, IG.Gr3d.VtkSurfacePlotBase.SurfaceColorIsScaled, IG.Gr3d.VtkSurfacePlotBase.SurfaceColorOpacity, and IG.Gr3d.VtkSurfacePlotBase.SurfacesVisible.

void IG.Gr3d.VtkPlotter.ShowFormContainerInThread | ( |  | ) |
| inline protected

Launches the form container.

References IG.Gr3d.VtkPlotBase.AddActorsToPlotter(), IG.Gr3d.VtkControlBase.LoadVtkGraphics, IG.Gr3d.VtkControlBase.VtkControl, IG.Gr3d.VtkControlBase.VtkRenderer, IG.Gr3d.VtkControlBase.VtkRenderWindow, and IG.Gr3d.VtkControlBase.VtkRenderWindowControl.

void IG.Gr3d.VtkPlotter.ShowFormContainer | ( |  | ) |
| inline protected

Shows the form container.

Dependent on the value of the FormContainerParallel property, the form container may be shown in a parallel thread, which means that other form containers can be shown in parallel before the current one is closed.

void IG.Gr3d.VtkPlotter.ShowPlot | ( |  | ) |
| inline

Shows the plot in the rendering window and allows user interactor for rotating, zooming, etc.

Referenced by IG.Gr3d.VtkPlotBase.ExampleCurvePlotLissajous(), IG.Gr3d.VtkPlotBase.ExampleCurvePlotTorusKnot(), and IG.Gr3d.VtkPlotBase.ExamplePlotterDecoration().

void IG.Gr3d.VtkPlotter.SetBoundsScaled | ( | IBoundingBox | bounds | ) |
| inline

Sets the bounds of scaled graphs.

Parameters

  bounds | Bounds of scaled graph to be set. Bounds are just copied to the internal data structure.

Referenced by IG.Gr3d.VtkPlotBase.ExampleSurfacePlotScaled().

void IG.Gr3d.VtkPlotter.ScaleCoordinatesPlain | ( | IVector | original,
|  | ref IVector | scaled
| ) |  |
| inline

Scales coordinates from the physical (original) coordinate system to the scaled graphical coordinates.

Parameters

  original | Vector of physical (original) coordinates.
  scaled | Vector of graphical coordinates.

References IG.Num.BoundingBoxBase.Map().

void IG.Gr3d.VtkPlotter.CalculateScalingParameters | ( |  | ) |
| inline

Calculates parameters for performing mapping on VTK actors.

References IG.Num.vec3.x, IG.Num.vec3.y, and IG.Num.vec3.z.

void IG.Gr3d.VtkPlotter.ScaleActor | ( | vtkActor | actor | ) |
| inline

Performs scaling on the specified VTK actor.

Also calculates parameters of mapping before scaling is applied.

Scaling is performed regardless of the value of the scaling flad (the IsScaled property).

Parameters

  actor | Actor whose coordinates are mapped (scaled).

void IG.Gr3d.VtkPlotter.ScaleActorPlain | ( | vtkActor | actor | ) |
| inline

Performs scaling on the specified VTK actor.

Parameters of mapping must be calculated before this method is called. This is done by the CalculateScalingParameters method.

Scaling is performed regardless of the value of the scaling flad (the IsScaled property).

Parameters

  actor | Actor whose coordinates are mapped (scaled).

References IG.Num.vec3.x, IG.Num.vec3.y, and IG.Num.vec3.z.

Referenced by IG.Gr3d.VtkPlotBase.ScaleActors().

void IG.Gr3d.VtkPlotter.ScaleActors | ( |  | ) |
| inline

Scales all actors on all plots of the bounding box.

References IG.Gr3d.VtkPlotBase.ScaleActors().

void IG.Gr3d.VtkPlotter.ScaleDecorations | ( |  | ) |
| inline

Scales decorations, including the axes, according to scaling defined on this plotter.

Scaling is performed regardless of the value of the scaling flad (the IsScaled property).

void IG.Gr3d.VtkPlotter.Dispose | ( |  | ) |
| inline

Implementation of IDisposable interface.

virtual void IG.Gr3d.VtkPlotter.Dispose | ( | bool | disposing | ) |
| inline protected virtual

Does the job of freeing resources.

This method can be eventually overridden in derived classes (if they use other resources that must be freed - in addition to such resources of the current class). In the case of overriding this method, you should usually call the base.Dispose(disposing ). in the overriding method.

Parameters

  disposing | Tells whether the method has been called form Dispose() method.

## Member Data Documentation

object IG.Gr3d.VtkPlotter._mainLock = new object()
| private

int IG.Gr3d.VtkPlotter._defaultOutputLevel = -1
| static protected

int IG.Gr3d.VtkPlotter._outputLevel = DefaultOutputLevel
| private

bool IG.Gr3d.VtkPlotter._isWindowStandalone = true
| private

int IG.Gr3d.VtkPlotter._windowSizeX = 600
| private

int IG.Gr3d.VtkPlotter._windowSizey = 600
| private

int IG.Gr3d.VtkPlotter._windowPositionX = 100
| private

int IG.Gr3d.VtkPlotter._windowPositionY = 50
| private

color IG.Gr3d.VtkPlotter.DefaultBackground = new color(1,1,1)
| static

Default background color for new windows.

color IG.Gr3d.VtkPlotter._backGround = DefaultBackground
| private

vtkRenderWindow IG.Gr3d.VtkPlotter._window
| private

bool IG.Gr3d.VtkPlotter.DefaultIsAllowedVtkForm = false
| static

Default value for flag indicating whether the VtkForm is used for standalone VTK windows.

bool IG.Gr3d.VtkPlotter.DefaultIsAllowedVtkFormPlain = true
| static

Default value for flag indicating whether the VtkFormPlain is used for stand-alone VTK windows.

bool IG.Gr3d.VtkPlotter._isAllowedVtkForm = DefaultIsAllowedVtkForm
| protected

bool IG.Gr3d.VtkPlotter._isAllowedVtkFormPlain = DefaultIsAllowedVtkFormPlain
| protected

IVtkFormContainer IG.Gr3d.VtkPlotter._formContainer
| private

Kitware.VTK.RenderWindowControl IG.Gr3d.VtkPlotter._renderControl
| private

VtkDecorationHandler IG.Gr3d.VtkPlotter._decorationHandler

List<VtkPlotBase> IG.Gr3d.VtkPlotter._plotObjects
| protected

int IG.Gr3d.VtkPlotter._activeRendererIndex = 0
| private

vtkRenderer IG.Gr3d.VtkPlotter._activeRenderer
| private

BoundingBox3d IG.Gr3d.VtkPlotter._boundsCoordinates
| private

bool IG.Gr3d.VtkPlotter._skipNullWindowCheck = false
| protected

const bool IG.Gr3d.VtkPlotter.DefaultFormContainerModal = true

Default value of the flag that specifies whether VTK form containers are launched as modal forms.

bool IG.Gr3d.VtkPlotter._formContainerModal = DefaultFormContainerModal
| private

bool IG.Gr3d.VtkPlotter.DefaultFormContainerParallel = false
| static

Default value of the flag that specifies whether or not form containers that contain VTK graphics are launched in parallel thread.

bool IG.Gr3d.VtkPlotter._formContainerParallel = DefaultFormContainerParallel
| private

bool IG.Gr3d.VtkPlotter._windowCreated = false
| protected

Whether the VTK window has been created, used for internal communication between some methods.

bool IG.Gr3d.VtkPlotter._isScaled = false
| protected

BoundingBox3d IG.Gr3d.VtkPlotter._boundsScaled
| private

Vector3d IG.Gr3d.VtkPlotter.vecOriginal = new Vector3d(0)
| private

Vector3d IG.Gr3d.VtkPlotter.vecScaled = new Vector3d(0)
| private

vec3 IG.Gr3d.VtkPlotter.ScalingFactors = new vec3()
| protected

Scaling factors - mapping parameters used when scaling VTK actors.

vec3 IG.Gr3d.VtkPlotter.ScalingTranslations = new vec3()
| protected

Scaling translations - mapping parameters used when scaling VTK actors.

bool IG.Gr3d.VtkPlotter.disposed = false
| private

## Property Documentation

object IG.Gr3d.VtkPlotter.Lock
| get

This object's central lock object to be used by other object. Do not use this object for locking in class' methods, for this you should use InternalLock.

int IG.Gr3d.VtkPlotter.DefaultOutputLevel
| static get set

Gets or sets the default level of output for this class.

When accessed for the first time, the current value of Util.OutputLevel is returned.

If set to less than 0 then the first subsequent set access will return the current the current value of Util.OutputLevel.

int IG.Gr3d.VtkPlotter.OutputLevel
| get set

Level of output to the console for the current object.

bool IG.Gr3d.VtkPlotter.IsWindowStandalone
| get set

Whether a stand-alone window is launched to render the scene.

int IG.Gr3d.VtkPlotter.WindowSizeX
| get set

Window size in x direction (used when a stand-alone window is launched for rendering).

Referenced by IG.Forms.VectorFunctionPlotter2d.ApplySurfacePlottterSettingsDefault().

int IG.Gr3d.VtkPlotter.WindowSizeY
| get set

Window size in y direction (used when a stand-alone window is launched for rendering).

Referenced by IG.Forms.VectorFunctionPlotter2d.ApplySurfacePlottterSettingsDefault().

int IG.Gr3d.VtkPlotter.WindowPositionX
| get set

Window position in x direction (used when a stand-alone window is launched for rendering).

int IG.Gr3d.VtkPlotter.WindowPositionY
| get set

Window position in y direction (used when a stand-alone window is launched for rendering).

color IG.Gr3d.VtkPlotter.BackGround
| get set

Background color for the current plotter.

If plotter is attached to a window that already has a renderer then background color of that renderer is set. If a renderer is created anew, this background color is assumed.

Referenced by IG.Forms.VectorFunctionPlotter2d.ApplySurfacePlottterSettingsDefault(), and IG.Gr3d.VtkPlotBase.ExamplePlotterDecoration().

vtkRenderWindow IG.Gr3d.VtkPlotter.Window
| get set protected

VTK window used for rendering 3D graphics. Warning: setter should only be used in constructors.

bool IG.Gr3d.VtkPlotter.DefaultIsAllowedAnyVtkForm
| static get set

Modifies or retrieves a boolean value indicating whether any VTK form can be used by plotters of the current type for standalone VTK windows by default.

bool IG.Gr3d.VtkPlotter.IsAllowedAnyVtkForm
| get set

Modifies or retrieves a boolean value indicating whether any VTK form can be used for standalone VTK windows by the current plotter.

bool IG.Gr3d.VtkPlotter.IsAllowedVtkForm
| get set

Whether the VtkForm is used for standalone VTK windows.

bool IG.Gr3d.VtkPlotter.IsAllowedVtkFormPlain
| get set

Whether the VtkFormPlain is used for stand-alone VTK windows.

IVtkFormContainer IG.Gr3d.VtkPlotter.FormContainer
| get set protected

Form that eventually contains VTK render control (of type Kitware.VTK.RenderWindowControl).

Kitware.VTK.RenderWindowControl IG.Gr3d.VtkPlotter.RenderControl
| get set protected

VTK control of type Kitware.VTK.RenderWindowControl that can be used for rendering VTK graphics.

VtkDecorationHandler IG.Gr3d.VtkPlotter.DecorationHandler
| get protected set

Decoration handler that handles graph axes, title, labels, etc.

Referenced by IG.Forms.VectorFunctionPlotter2d.ApplySurfacePlottterSettingsDefault(), and IG.Gr3d.VtkPlotBase.ExamplePlotterDecoration().

List<VtkPlotBase> IG.Gr3d.VtkPlotter.PlottingObjects
| get set protected

List of plotting objects contained on the current class.

Setter is thread safe.

Lazy evaluation - list object is automatically generated when first accessed.

int IG.Gr3d.VtkPlotter.NumRenderers
| get

Returns the number of renderers that are currently attached to the VTK window that is associated with the current VTK plotter object.

If htere is currently no VTK rendering windows associated with the plotter, there still can be an active renderer that has been allocated for adding actors, and in this case 1 is returned.

int IG.Gr3d.VtkPlotter.ActiveRendererIndex
| get set

Gets or sets the index of the active renderer. This is the renderer on which mathod such as AddActor operate.

vtkRenderer IG.Gr3d.VtkPlotter.Renderer
| get set protected

Gets the active renderer of the current VTK plotter.

BoundingBox3d IG.Gr3d.VtkPlotter.BoundsCoordinates
| get protected set

Bounds on coordinates of points that define the plots. Everything on the plot should fit in these bounds.

bool IG.Gr3d.VtkPlotter.FormContainerModal
| get set private

Whether or not VTK form containers are launched as modal forms.

bool IG.Gr3d.VtkPlotter.FormContainerParallel
| get set private

Whether or not form containers that contain VTK graphics are launched in parallel thread.

bool IG.Gr3d.VtkPlotter.IsScaled
| get set

Specifies whether coordinates of graphic objects are scaled when plottting.

Referenced by IG.Gr3d.VtkPlotBase.ExamplePlotterDecoration(), and IG.Gr3d.VtkPlotBase.ExampleSurfacePlotScaled().

BoundingBox3d IG.Gr3d.VtkPlotter.BoundsScaled
| get protected set

Bounds on scaled coordinates graphic objects. Everything on the scaled plot should fit in these bounds.

Getter always returns an allocated bounding box. By default, all coordinate bounds are set to [0, 1].

The documentation for this class was generated from the following file:

- extensions/igplot3d/plot3d/vtkbased/VtkPlotter.cs